Theme

- Main Page
- Related Pages
- Modules
- Data Structures
- Files
- Examples

Typedefs | Functions
Theme
Elementary

Elementary uses Edje to theme its widgets, naturally. More...

## Typedefs
typedef struct _Elm_Theme | Elm_Theme
| Opaque handler for the list of themes Elementary looks for when rendering widgets.

## Functions
Eina_List * | elm_theme_color_class_list (Elm_Theme *th)
| Return a list of strings of color classes used in the given theme.
void | elm_theme_color_class_list_free (Eina_List *list)
| Free list of color classes used in the themes.
Elm_Theme * | elm_theme_new (void)
| Create a new specific theme.
void | elm_theme_free (Elm_Theme *th)
| Free a specific theme.
void | elm_theme_copy (Elm_Theme *th, Elm_Theme *thdst)
| Copy the theme from the source to the destination theme.
void | elm_theme_ref_set (Elm_Theme *th, Elm_Theme *thref)
| Tell the source theme to reference the ref theme.
Elm_Theme * | elm_theme_ref_get (const Elm_Theme *th)
| Return the theme referred to.
Elm_Theme * | elm_theme_default_get (void)
| Return the default theme.
void | elm_theme_overlay_add (Elm_Theme *th, const char *item)
| Prepends a theme overlay to the list of overlays.
void | elm_theme_overlay_del (Elm_Theme *th, const char *item)
| Delete a theme overlay from the list of overlays.
void | elm_theme_overlay_mmap_add (Elm_Theme *th, const Eina_File *f)
| Prepends a theme overlay to the list of overlays.
void | elm_theme_overlay_mmap_del (Elm_Theme *th, const Eina_File *f)
| Delete a theme overlay from the list of overlays.
const Eina_List * | elm_theme_overlay_list_get (const Elm_Theme *th)
| Get the list of registered overlays for the given theme.
void | elm_theme_extension_add (Elm_Theme *th, const char *item)
| Appends a theme extension to the list of extensions.
void | elm_theme_extension_del (Elm_Theme *th, const char *item)
| Deletes a theme extension from the list of extensions.
void | elm_theme_extension_mmap_add (Elm_Theme *th, const Eina_File *f)
| Appends a theme extension to the list of extensions.
void | elm_theme_extension_mmap_del (Elm_Theme *th, const Eina_File *f)
| Deletes a theme extension from the list of extensions.
const Eina_List * | elm_theme_extension_list_get (const Elm_Theme *th)
| Get the list of registered extensions for the given theme.
void | elm_theme_set (Elm_Theme *th, const char *theme)
| Set the theme search order for the given theme.
const char * | elm_theme_get (Elm_Theme *th)
| Return the theme search order.
const Eina_List * | elm_theme_list_get (const Elm_Theme *th)
| Return a list of theme elements to be used in a theme.
char * | elm_theme_list_item_path_get (const char *f, Eina_Bool *in_search_path)
| Return the full path for a theme element.
void | elm_theme_flush (Elm_Theme *th)
| Flush the current theme.
void | elm_theme_full_flush (void)
| This flushes all themes (default and specific ones).
Eina_List * | elm_theme_name_available_list_new (void)
| Return a list of theme elements in the theme search path.
void | elm_theme_name_available_list_free (Eina_List *list)
| Free the list returned by elm_theme_name_available_list_new()
void | elm_object_theme_set (Evas_Object *obj, Elm_Theme *th)
| Set a specific theme to be used for this object and its children.
Elm_Theme * | elm_object_theme_get (const Evas_Object *obj)
| Get the specific theme to be used.
const char * | elm_theme_data_get (Elm_Theme *th, const char *key)
| Get a data item from a theme.
const char * | elm_theme_group_path_find (Elm_Theme *th, const char *group)
| Get the file path for an edje file for the group and theme given.
Eina_List * | elm_theme_group_base_list (Elm_Theme *th, const char *base)
| Get a list of groups that match the initial base string given within all themes.
const char * | elm_theme_system_dir_get (void)
| Get the file path where elementary system theme files are found.
const char * | elm_theme_user_dir_get (void)
| Get the file path where elementary user theme files are found.

## Detailed Description

Elementary uses Edje to theme its widgets, naturally.

But for the most part this is hidden behind a simpler interface that lets the user set extensions and choose the style of widgets in a much easier way.

Instead of thinking in terms of paths to Edje files and their groups each time you want to change the appearance of a widget, Elementary works so you can add any theme file with extensions or replace the main theme at one point in the application, and then just set the style of widgets with elm_object_style_set() and related functions. Elementary will then look in its list of themes for a matching group and apply it, and when the theme changes midway through the application, all widgets will be updated accordingly.

There are three concepts you need to know to understand how Elementary theming works: default theme, extensions and overlays.

Default theme, obviously enough, is the one that provides the default look of all widgets. End users can change the theme used by Elementary by setting the `ELM_THEME` environment variable before running an application, or globally for all programs using the `elementary_config` utility. Applications can change the default theme using elm_theme_set(), but this can go against the user wishes, so it's not an advised practice.

Ideally, applications should find everything they need in the already provided theme, but there may be occasions when that's not enough and custom styles are required to correctly express the idea. For this cases, Elementary has extensions.

Extensions allow the application developer to write styles of its own to apply to some widgets. This requires knowledge of how each widget is themed, as extensions will always replace the entire group used by the widget, so important signals and parts need to be there for the object to behave properly (see documentation of Edje for details). Once the theme for the extension is done, the application needs to add it to the list of themes Elementary will look into, using elm_theme_extension_add(), and set the style of the desired widgets as he would normally with elm_object_style_set().

Overlays, on the other hand, can replace the look of all widgets by overriding the default style. Like extensions, it's up to the application developer to write the theme for the widgets it wants, the difference being that when looking for the theme, Elementary will check first the list of overlays, then the set theme and lastly the list of extensions, so with overlays it's possible to replace the default view and every widget will be affected. This is very much alike to setting the whole theme for the application and will probably clash with the end user options, not to mention the risk of ending up with not matching styles across the program. Unless there's a very special reason to use them, overlays should be avoided for the reasons exposed before.

All these theme lists are handled by Elm_Theme instances. Elementary keeps one default internally and every function that receives one of these can be called with NULL to refer to this default (except for elm_theme_free()). It's possible to create a new instance of a Elm_Theme to set other theme for a specific widget (and all of its children), but this is as discouraged, if not even more so, than using overlays. Don't use this unless you really know what you are doing.

But to be less negative about things, you can look at the following examples:

- Using extensions
- Using overlays

## Typedef Documentation

## ◆ Elm_Theme

Elm_Theme

Opaque handler for the list of themes Elementary looks for when rendering widgets.

Stay out of this unless you really know what you are doing. For most cases, sticking to the default is all a developer needs.

## Function Documentation

## ◆ elm_theme_color_class_list()

Eina_List * elm_theme_color_class_list | ( | Elm_Theme * | th | ) |

Return a list of strings of color classes used in the given theme.

Parameters

  th | The theme to get the reference from (NULL will be default)

Returns
  The list of color classes

Free the returned list using elm_theme_color_class_list_free() when done.

@sizne 1.26

References EINA_COMPARE_CB, eina_hash_add(), eina_hash_find(), eina_hash_foreach(), eina_hash_free(), eina_hash_string_superfast_new(), EINA_LIST_FREE, eina_list_sort(), and eina_stringshare_del().

## ◆ elm_theme_color_class_list_free()

void elm_theme_color_class_list_free | ( | Eina_List * | list | ) |

Free list of color classes used in the themes.

Parameters

  list | The list to free

Free the returned list returned from elm_theme_color_class_list()

@sizne 1.26

References EINA_LIST_FREE, and eina_stringshare_del().

## ◆ elm_theme_new()

Elm_Theme * elm_theme_new | ( | void |  | ) |

Create a new specific theme.

This creates an empty specific theme that only uses the default theme. A specific theme has its own private set of extensions and overlays too (which are empty by default). Specific themes do not fall back to themes of parent objects. They are not intended for this use. Use styles, overlays and extensions when needed, but avoid specific themes unless there is no other way (example: you want to have a preview of a new theme you are selecting in a "theme selector" window. The preview is inside a scroller and should display what the theme you selected will look like, but not actually apply it yet. The child of the scroller will have a specific theme set to show this preview before the user decides to apply it to all applications).

## ◆ elm_theme_free()

void elm_theme_free | ( | Elm_Theme * | th | ) |

Free a specific theme.

Parameters

  th | The theme to free

This frees a theme created with elm_theme_new().

References EINA_SAFETY_ON_NULL_RETURN.

## ◆ elm_theme_copy()

void elm_theme_copy | ( | Elm_Theme * | th,
|  | Elm_Theme * | thdst
| ) |  |

Copy the theme from the source to the destination theme.

Parameters

  th | The source theme to copy from
  thdst | The destination theme to copy data to

This makes a one-time static copy of all the theme config, extensions and overlays from `th` to `thdst`. If `th` references a theme, then `thdst` is also set to reference it, with all the theme settings, overlays and extensions that `th` had.

References eina_list_append(), eina_stringshare_add(), and elm_theme_flush().

## ◆ elm_theme_ref_set()

void elm_theme_ref_set | ( | Elm_Theme * | th,
|  | Elm_Theme * | thref
| ) |  |

Tell the source theme to reference the ref theme.

Parameters

  th | The theme that will do the referencing
  thref | The theme that is the reference source

This clears `th` to be empty and then sets it to refer to `thref` so `th` acts as an override to `thref`, but where its overrides don't apply, it will fall through to `thref` for configuration.

References eina_list_append(), and elm_theme_flush().

## ◆ elm_theme_ref_get()

Elm_Theme * elm_theme_ref_get | ( | const Elm_Theme * | th | ) |

Return the theme referred to.

Parameters

  th | The theme to get the reference from

Returns
  The referenced theme handle

This gets the theme set as the reference theme by elm_theme_ref_set(). If no theme is set as a reference, NULL is returned.

## ◆ elm_theme_default_get()

Elm_Theme * elm_theme_default_get | ( | void |  | ) |

Return the default theme.

Returns
  The default theme handle

This returns the internal default theme setup handle that all widgets use implicitly unless a specific theme is set. This is also often use as a shorthand of NULL.

## ◆ elm_theme_overlay_add()

void elm_theme_overlay_add | ( | Elm_Theme * | th,
|  | const char * | item
| ) |  |

Prepends a theme overlay to the list of overlays.

Parameters

  th | The theme to add to, or if NULL, the default theme
  item | The Edje file path to be used

Use this if your application needs to provide some custom overlay theme (An Edje file that replaces some default styles of widgets) where adding new styles, or changing system theme configuration is not possible. Do NOT use this instead of a proper system theme configuration. Use proper configuration files, profiles, environment variables etc. to set a theme so that the theme can be altered by simple configuration by a user. Using this call to achieve that effect is abusing the API and will create lots of trouble.

See also
  elm_theme_extension_add()
  elm_theme_overlay_mmap_add()

## ◆ elm_theme_overlay_del()

void elm_theme_overlay_del | ( | Elm_Theme * | th,
|  | const char * | item
| ) |  |

Delete a theme overlay from the list of overlays.

Parameters

  th | The theme to delete from, or if NULL, the default theme
  item | The name of the theme overlay

See also
  elm_theme_overlay_add()

## ◆ elm_theme_overlay_mmap_add()

void elm_theme_overlay_mmap_add | ( | Elm_Theme * | th,
|  | const Eina_File * | f
| ) |  |

Prepends a theme overlay to the list of overlays.

Parameters

  th | The theme to add to, or if NULL, the default theme
  f | The Edje file handle to be used

Use this if your application needs to provide some custom overlay theme (An Edje file that replaces some default styles of widgets) where adding new styles, or changing system theme configuration is not possible. Do NOT use this instead of a proper system theme configuration. Use proper configuration files, profiles, environment variables etc. to set a theme so that the theme can be altered by simple configuration by a user. Using this call to achieve that effect is abusing the API and will create lots of trouble.

See also
  elm_theme_extension_add()
  elm_theme_overlay_add()

References EINA_FALSE, eina_file_close(), eina_file_dup(), eina_file_filename_get(), eina_list_free(), EINA_TRUE, and elm_theme_flush().

## ◆ elm_theme_overlay_mmap_del()

void elm_theme_overlay_mmap_del | ( | Elm_Theme * | th,
|  | const Eina_File * | f
| ) |  |

Delete a theme overlay from the list of overlays.

Parameters

  th | The theme to delete from, or if NULL, the default theme
  f | The file handle of the theme overlay

See also
  elm_theme_overlay_mmap_add()

References eina_list_free(), and elm_theme_flush().

## ◆ elm_theme_overlay_list_get()

const Eina_List * elm_theme_overlay_list_get | ( | const Elm_Theme * | th | ) |

Get the list of registered overlays for the given theme.

Parameters

  th | The theme from which to get the overlays

Returns
  List of theme overlays. Do not free it.

See also
  elm_theme_overlay_add()

References EINA_INLIST_FOREACH, and eina_list_append().

## ◆ elm_theme_extension_add()

void elm_theme_extension_add | ( | Elm_Theme * | th,
|  | const char * | item
| ) |  |

Appends a theme extension to the list of extensions.

Parameters

  th | The theme to add to, or if NULL, the default theme
  item | The Edje file path to be used

This is intended when an application needs more styles of widgets or new widget themes that the default does not provide (or may not provide). The application has "extended" usage by coming up with new custom style names for widgets for specific uses, but as these are not "standard", they are not guaranteed to be provided by a default theme. This means the application is required to provide these extra elements itself in specific Edje files. This call adds one of those Edje files to the theme search path to be search after the default theme. The use of this call is encouraged when default styles do not meet the needs of the application. Use this call instead of elm_theme_overlay_add() for almost all cases.

See also
  elm_object_style_set()

## ◆ elm_theme_extension_del()

void elm_theme_extension_del | ( | Elm_Theme * | th,
|  | const char * | item
| ) |  |

Deletes a theme extension from the list of extensions.

Parameters

  th | The theme to delete from, or if NULL, the default theme
  item | The name of the theme extension

See also
  elm_theme_extension_add()

## ◆ elm_theme_extension_mmap_add()

void elm_theme_extension_mmap_add | ( | Elm_Theme * | th,
|  | const Eina_File * | f
| ) |  |

Appends a theme extension to the list of extensions.

Parameters

  th | The theme to add to, or if NULL, the default theme
  f | The Edje file handle to be used

This is intended when an application needs more styles of widgets or new widget themes that the default does not provide (or may not provide). The application has "extended" usage by coming up with new custom style names for widgets for specific uses, but as these are not "standard", they are not guaranteed to be provided by a default theme. This means the application is required to provide these extra elements itself in specific Edje files. This call adds one of those Edje files to the theme search path to be search after the default theme. The use of this call is encouraged when default styles do not meet the needs of the application. Use this call instead of elm_theme_overlay_add() for almost all cases.

See also
  elm_object_style_set()

References EINA_FALSE, eina_file_dup(), eina_file_filename_get(), eina_list_free(), and elm_theme_flush().

## ◆ elm_theme_extension_mmap_del()

void elm_theme_extension_mmap_del | ( | Elm_Theme * | th,
|  | const Eina_File * | f
| ) |  |

Deletes a theme extension from the list of extensions.

Parameters

  th | The theme to delete from, or if NULL, the default theme
  f | The file handle of the theme extension

See also
  elm_theme_extension_add()

References eina_list_free(), and elm_theme_flush().

## ◆ elm_theme_extension_list_get()

const Eina_List * elm_theme_extension_list_get | ( | const Elm_Theme * | th | ) |

Get the list of registered extensions for the given theme.

Parameters

  th | The theme from which to get the extensions

Returns
  List of theme extensions. Do not free it.

See also
  elm_theme_extension_add()

References EINA_INLIST_FOREACH, and eina_list_append().

## ◆ elm_theme_set()

void elm_theme_set | ( | Elm_Theme * | th,
|  | const char * | theme
| ) |  |

Set the theme search order for the given theme.

Parameters

  th | The theme to set the search order, or if NULL, the default theme
  theme | Theme search string

This sets the search string for the theme in path-notation from first theme to search, to last, delimited by the : character. Example:

"shiny:/path/to/file.edj:default"

See the ELM_THEME environment variable for more information.

See also
  elm_theme_get()
  elm_theme_list_get()

References eina_stringshare_del(), eina_stringshare_replace(), and elm_theme_flush().

## ◆ elm_theme_get()

const char * elm_theme_get | ( | Elm_Theme * | th | ) |

Return the theme search order.

Parameters

  th | The theme to get the search order, or if NULL, the default theme

Returns
  The internal search order path

This function returns a colon separated string of theme elements as returned by elm_theme_list_get().

See also
  elm_theme_set()
  elm_theme_list_get()

References EINA_INLIST_FOREACH, EINA_INLIST_GET, eina_strbuf_append_char(), eina_strbuf_free(), eina_strbuf_new(), eina_strbuf_string_get(), and eina_stringshare_add().

## ◆ elm_theme_list_get()

const Eina_List * elm_theme_list_get | ( | const Elm_Theme * | th | ) |

Return a list of theme elements to be used in a theme.

Parameters

  th | Theme to get the list of theme elements from.

Returns
  The internal list of theme elements

This returns the internal list of theme elements (will only be valid as long as the theme is not modified by elm_theme_set() or theme is not freed by elm_theme_free(). This is a list of strings which must not be altered as they are also internal. If `th` is NULL, then the default theme element list is returned.

A theme element can consist of a full or relative path to a .edj file, or a name, without extension, for a theme to be searched in the known theme paths for Elementary.

See also
  elm_theme_set()
  elm_theme_get()

References EINA_INLIST_FOREACH, and eina_list_append().

## ◆ elm_theme_list_item_path_get()

char * elm_theme_list_item_path_get | ( | const char * | f,
|  | Eina_Bool * | in_search_path
| ) |  |

Return the full path for a theme element.

Parameters

  f | The theme element name
  in_search_path | Pointer to a boolean to indicate if item is in the search path or not

Returns
  The full path to the file found.

This returns a string you should free with free() on success, NULL on failure. This will search for the given theme element, and if it is a full or relative path element or a simple search-able name. The returned path is the full path to the file, if searched, and the file exists, or it is simply the full path given in the element or a resolved path if relative to home. The `in_search_path` boolean pointed to is set to `EINA_TRUE` if the file was a search-able file and is in the search path, and `EINA_FALSE` otherwise.

References ecore_file_exists(), eina_environment_home_get(), EINA_FALSE, and EINA_TRUE.

## ◆ elm_theme_flush()

void elm_theme_flush | ( | Elm_Theme * | th | ) |

Flush the current theme.

Parameters

  th | Theme to flush

This flushes caches that let elementary know where to find theme elements in the given theme. If `th` is NULL, then the default theme is flushed. Call this function if source theme data has changed in such a way as to make any caches Elementary kept invalid.

References eina_file_close(), EINA_FREE_CB, eina_hash_free(), eina_hash_string_superfast_new(), EINA_LIST_FOREACH, eina_stringshare_del(), EINA_TRUE, and elm_theme_flush().

Referenced by elm_theme_copy(), elm_theme_extension_mmap_add(), elm_theme_extension_mmap_del(), elm_theme_flush(), elm_theme_full_flush(), elm_theme_overlay_mmap_add(), elm_theme_overlay_mmap_del(), elm_theme_ref_set(), and elm_theme_set().

## ◆ elm_theme_full_flush()

void elm_theme_full_flush | ( | void |  | ) |

This flushes all themes (default and specific ones).

This will flush all themes in the current application context, by calling elm_theme_flush() on each of them.

References EINA_LIST_FOREACH, and elm_theme_flush().

## ◆ elm_theme_name_available_list_new()

Eina_List * elm_theme_name_available_list_new | ( | void |  | ) |

Return a list of theme elements in the theme search path.

Returns
  A list of strings that are the theme element names.

This lists all available theme files in the standard Elementary search path for theme elements, and returns them in alphabetical order as theme element names in a list of strings. Free this with elm_theme_name_available_list_free() when you are done with the list.

References ecore_file_is_dir(), ecore_file_ls(), ecore_file_size(), EINA_COMPARE_CB, eina_environment_home_get(), eina_list_append(), EINA_LIST_FOREACH, EINA_LIST_FREE, eina_list_sort(), and eina_str_has_extension().

## ◆ elm_theme_name_available_list_free()

void elm_theme_name_available_list_free | ( | Eina_List * | list | ) |

Free the list returned by elm_theme_name_available_list_new()

This frees the list of themes returned by elm_theme_name_available_list_new(). Once freed the list should no longer be used. a new list mys be created.

References EINA_LIST_FREE.

## ◆ elm_object_theme_set()

void elm_object_theme_set | ( | Evas_Object * | obj,
|  | Elm_Theme * | th
| ) |  |

Set a specific theme to be used for this object and its children.

Parameters

  obj | The object to set the theme on
  th | The theme to set

This sets a specific theme that will be used for the given object and any child objects it has. If `th` is NULL then the theme to be used is cleared and the object will inherit its theme from its parent (which ultimately will use the default theme if no specific themes are set).

Use special themes with great care as this will annoy users and make configuration difficult. Avoid any custom themes at all if it can be helped.

References EINA_SAFETY_ON_NULL_RETURN.

## ◆ elm_object_theme_get()

Elm_Theme * elm_object_theme_get | ( | const Evas_Object * | obj | ) |

Get the specific theme to be used.

Parameters

  obj | The object to get the specific theme from

Returns
  The specific theme set.

This will return a specific theme set, or NULL if no specific theme is set on that object. It will not return inherited themes from parents, only the specific theme set for that specific object. See elm_object_theme_set() for more information.

References EINA_SAFETY_ON_NULL_RETURN_VAL.

## ◆ elm_theme_data_get()

const char * elm_theme_data_get | ( | Elm_Theme * | th,
|  | const char * | key
| ) |  |

Get a data item from a theme.

Parameters

  th | The theme, or NULL for default theme
  key | The data key to search with

Returns
  The data value, or NULL on failure

This function is used to return data items from edc in `th`, an overlay, or an extension. It works the same way as edje_file_data_get() except that the return is stringshared.

## ◆ elm_theme_group_path_find()

const char * elm_theme_group_path_find | ( | Elm_Theme * | th,
|  | const char * | group
| ) |  |

Get the file path for an edje file for the group and theme given.

Parameters

  th | The theme, or NULL for default theme
  group | The group in the edje file to look for

Returns
  The full path to the file as a string

This function looks up the given edje `group` in the set of theme edje files configured for the theme `th` (which if NULL indicates the default theme). If not found in any, NULL wil be returned. If found, the string returned is internal and should not be freed, but will only be valid until the theme is re-configured, or cache flushed, so if the string needs to be kept, duplicate it and store that. The string will be a stringshare string that is returned by functions like eina_stringshare_add() so it can be just references via stringshare functions if desired.

If group is NULL, then nothing can be looked up.

Since
  1.8

References eina_file_filename_get(), and EINA_SAFETY_ON_NULL_RETURN_VAL.

## ◆ elm_theme_group_base_list()

Eina_List * elm_theme_group_base_list | ( | Elm_Theme * | th,
|  | const char * | base
| ) |  |

Get a list of groups that match the initial base string given within all themes.

Parameters

  th | The theme, or NULL for default theme
  base | The base string group collection to look for

Returns
  A list of collection names (sorted) or NULL if none found

This function will walk all theme files configured in the theme `th` (or NULL if it's the default) and find all groups that BEGIN with the string `begin` and have that string as at LEAST their start, and then add the full group name that matches to the list and return that full group string.

The list returned must be freed by the caller, with each string being a stringshared string to be freed with eina_stringshare_del(). Not doing so may result in a leak.

Since
  1.8

References EINA_COMPARE_CB, eina_list_sort(), and EINA_SAFETY_ON_NULL_RETURN_VAL.

## ◆ elm_theme_system_dir_get()

const char * elm_theme_system_dir_get | ( | void |  | ) |

Get the file path where elementary system theme files are found.

Returns
  A string that holds the path where system themes are

This returns the location in the filesystem where the system themes are to be found that elementary looks for. This is useful for something that wishes toiterate over the files in this folder and display them, for example a theme selector.

Since
  1.8

## ◆ elm_theme_user_dir_get()

const char * elm_theme_user_dir_get | ( | void |  | ) |

Get the file path where elementary user theme files are found.

Returns
  A string that holds the path where user themes are

This returns the location in the filesystem where the user themes are to be found that elementary looks for. This is useful for something that wishes toiterate over the files in this folder and display them, for example a theme selector.

User themes are always looked for before system themes. The user theme directory is normally expected to be writable by the user.

Since
  1.8

References eina_environment_home_get().